package queens
package axis.fifth.output
package database


package object scalikejdbc {

  def init(
    driver: Symbol,
    plainSQL: Boolean = false
  ): Unit =
    if (plainSQL)
      plainsql.init(driver)
    else
      dao.init(driver)


  def drop(
    driver: Symbol,
    plainSQL: Boolean = false
  ): Unit =
    if (plainSQL)
      plainsql.drop(driver)
    else
      dao.drop(driver)

}


package scalikejdbc {


  package object plainsql {

    import _root_.scalikejdbc._

    val X = 0


    def init(
      driver: Symbol
    ): Unit = {

      NamedDB(driver) autoCommit { implicit session =>

        sql"""create table "BOARDS"(
                "ID" int generated by default as identity,
                "SIZE" int,
                primary key ("ID")
              )
           """.execute()()
        sql"""create table "SQUARES"(
                "BOARD_ID" int,
                "ROW_NO" int,
                "COLUMN" int,
                "IS_FREE" bool,
                constraint "SQUARES_BOARD_FK" foreign key ("BOARD_ID") references "BOARDS"("ID")
              )
           """.execute()()
        sql"""create table "QUEENS"(
                "ID" int generated by default as identity,
                "ASPECT_ID" int,
                "ALGORITHM_ID" int,
                "MODEL_ID" int,
                "INTERFACE_ID" int,
                "USE_ID" int,
                "TAGS" varchar,
                primary key ("ID"),
                constraint "ASPECT_FK" foreign key ("ASPECT_ID") references "ASPECTS"("ID"),
                constraint "ALGORITHM_FK" foreign key ("ALGORITHM_ID") references "ALGORITHMS"("ID"),
                constraint "MODEL_FK" foreign key ("MODEL_ID") references "MODELS"("ID"),
                constraint "INTERFACE_FK" foreign key ("INTERFACE_ID") references "INTERFACES"("ID"),
                constraint "USE_FK" foreign key ("USE_ID") references "USES"("ID")
              )
           """.execute()()
        sql"""create table "ROUNDS"(
                "ID" int generated by default as identity,
                "BOARD_ID" int,
                "QUEEN_ID" int,
                "TAG" varchar,
                "NUMBER" int,
                primary key ("ID"),
                constraint "ROUNDS_BOARD_FK" foreign key ("BOARD_ID") references "BOARDS"("ID"),
                constraint "QUEEN_FK" foreign key ("QUEEN_ID") references "QUEENS"("ID")
              )
           """.execute()()
        sql"""create table "SOLUTIONS"(
                "ID" int generated by default as identity,
                "ROUND_ID" int,
                "NUMBER" int,
                primary key ("ID"),
                constraint "ROUND_FK" foreign key ("ROUND_ID") references "ROUNDS"("ID")
              )
           """.execute()()
        sql"""create table "SOLUTION_POINTS"(
                "SOLUTION_ID" int,
                "ROW_NO" int,
                "COLUMN" int,
                constraint "SOLUTION_FK" foreign key ("SOLUTION_ID") references "SOLUTIONS"("ID")
              )
           """.execute()()

      }

    }


    def drop(
      driver: Symbol
    ): Unit = {

      NamedDB(driver) autoCommit { implicit session =>

        sql"""drop table "SOLUTION_POINTS"""".execute()()
        sql"""drop table "SOLUTIONS"""".execute()()
        sql"""drop table "ROUNDS"""".execute()()
        sql"""drop table "QUEENS"""".execute()()
        sql"""drop table "SQUARES"""".execute()()
        sql"""drop table "BOARDS"""".execute()()

      }

    }

  }


  package object h2 {

    def init(
      driver: Symbol,
      plainSQL: Boolean = false
    ): Unit = {
      dbdimensions.init(driver, plainSQL)

      database.scalikejdbc.init(driver, plainSQL)
    }

    def drop(
      driver: Symbol,
      plainSQL: Boolean = false
    ): Unit = {
      database.scalikejdbc.drop(driver, plainSQL)

      dbdimensions.drop(driver, plainSQL)
    }

  }


  package object sqlite {

    import _root_.scalikejdbc._

    def init(
      driver: Symbol,
      plainSQL: Boolean = false
    ): Unit = {
      dbdimensions.init(driver, plainSQL)

      NamedDB(driver) autoCommit { implicit session =>

        sql"""create table "BOARDS"(
                "ID" integer primary key autoincrement,
                "SIZE" int
              )
           """.execute()()
        sql"""create table "SQUARES"(
                "BOARD_ID" integer,
                "ROW_NO" int,
                "COLUMN" int,
                "IS_FREE" int,
                constraint "SQUARES_BOARD_FK" foreign key ("BOARD_ID") references "BOARDS"("ID")
              )
           """.execute()()
        sql"""create table "QUEENS"(
                "ID" integer primary key autoincrement,
                "ASPECT_ID" integer,
                "ALGORITHM_ID" integer,
                "MODEL_ID" integer,
                "INTERFACE_ID" integer,
                "USE_ID" integer,
                "TAGS" text,
                constraint "ASPECT_FK" foreign key ("ASPECT_ID") references "ASPECTS"("ID"),
                constraint "ALGORITHM_FK" foreign key ("ALGORITHM_ID") references "ALGORITHMS"("ID"),
                constraint "MODEL_FK" foreign key ("MODEL_ID") references "MODELS"("ID"),
                constraint "INTERFACE_FK" foreign key ("INTERFACE_ID") references "INTERFACES"("ID"),
                constraint "USE_FK" foreign key ("USE_ID") references "USES"("ID")
              )
           """.execute()()
        sql"""create table "ROUNDS"(
                "ID" integer primary key autoincrement,
                "BOARD_ID" integer,
                "QUEEN_ID" integer,
                "TAG" text NOT NULL,
                "NUMBER" int,
                constraint "ROUNDS_BOARD_FK" foreign key ("BOARD_ID") references "BOARDS"("ID"),
                constraint "QUEEN_FK" foreign key ("QUEEN_ID") references "QUEENS"("ID")
              )
           """.execute()()
        sql"""create table "SOLUTIONS"(
                "ID" integer primary key autoincrement,
                "ROUND_ID" integer,
                "NUMBER" int,
                constraint "ROUND_FK" foreign key ("ROUND_ID") references "ROUNDS"("ID")
              )
           """.execute()()
        sql"""create table "SOLUTION_POINTS"(
                "SOLUTION_ID" integer,
                "ROW_NO" int,
                "COLUMN" int,
                constraint "SOLUTION_FK" foreign key ("SOLUTION_ID") references "SOLUTIONS"("ID")
              )
           """.execute()()

      }

    }

    def drop(
      driver: Symbol,
      plainSQL: Boolean = false
    ): Unit = {
      database.scalikejdbc.drop(driver, plainSQL)

      dbdimensions.drop(driver, plainSQL)
    }

  }

}
